'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function padValue(value, width) {
  var padCharacter = arguments.length <= 2 || arguments[2] === undefined ? '0' : arguments[2];

  value = value + '';
  return value.length >= width ? value : new Array(width - value.length + 1).join(padCharacter) + value;
}

function isIntegerString(str) {
  str = '' + str;
  return !!str && !!str.match(/^\d*$/g);
}

function sanitizeIntegerInput(str) {
  var fallBackValue = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

  return isIntegerString(str) ? parseInt(str) : fallBackValue;
}

var NumberInput = (function (_Component) {
  _inherits(NumberInput, _Component);

  _createClass(NumberInput, null, [{
    key: 'defaultProps',
    value: {
      value: 0,
      minValue: null,
      maxValue: null,
      maxLength: null,
      enableZeroFill: false
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      value: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]).isRequired,
      onChange: _react.PropTypes.func.isRequired,
      minValue: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
      maxValue: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
      maxLength: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
      enableZeroFill: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function NumberInput(props) {
    var _this = this;

    _classCallCheck(this, NumberInput);

    _get(Object.getPrototypeOf(NumberInput.prototype), 'constructor', this).call(this, props);
    this.state = this.mapPropsToComponentState(this.props);

    this.onChange = function (event) {
      var stringValue = event.target.value;
      var inputIsValid = _this.isValid(stringValue);
      var numericalValue = sanitizeIntegerInput(stringValue);

      _this.setState({
        inputIsValid: inputIsValid,
        stringValue: stringValue,
        numericalValue: numericalValue
      });

      if (!inputIsValid) {
        event.target.select();
      }
    };

    this.onFocus = function (event) {
      event.target.select();
    };

    this.onBlur = function (event) {
      var _state = _this.state;
      var inputIsValid = _state.inputIsValid;
      var numericalValue = _state.numericalValue;
      var stringValue = _state.stringValue;
      var enableZeroFill = _state.enableZeroFill;
      var maxLength = _state.maxLength;

      if (inputIsValid) {
        _this.props.onChange(numericalValue);
        _this.setState({
          value: _this.props.enableZeroFill && _this.props.maxLength ? padValue(numericalValue, maxLength) : '' + _this.state.stringValue
        });
      }
    };
  }

  _createClass(NumberInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.mapPropsToComponentState(nextProps));
    }
  }, {
    key: 'mapPropsToComponentState',
    value: function mapPropsToComponentState(props) {
      return {
        numericalValue: sanitizeIntegerInput(props.value),
        stringValue: this.addZeroFill(props.value),
        minValue: sanitizeIntegerInput(props.minValue),
        maxValue: sanitizeIntegerInput(props.maxValue),
        maxLength: sanitizeIntegerInput(props.maxLength),
        enableZeroFill: props.enableZeroFill,
        inputIsValid: this.isValid(props.value)
      };
    }
  }, {
    key: 'addZeroFill',
    value: function addZeroFill(value) {
      var _props = this.props;
      var maxLength = _props.maxLength;
      var enableZeroFill = _props.enableZeroFill;

      return enableZeroFill && sanitizeIntegerInput(maxLength) ? padValue(value, maxLength) : '' + value;
    }
  }, {
    key: 'isValid',
    value: function isValid(str) {
      var minValue = sanitizeIntegerInput(this.props.minValue);
      var maxValue = sanitizeIntegerInput(this.props.maxValue);
      var number = sanitizeIntegerInput(str);

      if (number === null) {
        return false;
      } else if (minValue !== null && number < minValue) {
        return false;
      } else if (maxValue !== null && number > maxValue) {
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _state2 = this.state;
      var inputIsValid = _state2.inputIsValid;
      var stringValue = _state2.stringValue;
      var maxLength = _state2.maxLength;

      return _react2['default'].createElement('input', {
        className: inputIsValid ? 'number-input' : 'number-input invalid',
        type: 'text',
        value: stringValue,
        maxLength: maxLength,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        onChange: this.onChange });
    }
  }]);

  return NumberInput;
})(_react.Component);

exports['default'] = NumberInput;
module.exports = exports['default'];